package ru.dbotthepony.mc.otm.network

import net.minecraft.network.FriendlyByteBuf
import net.minecraft.network.codec.StreamCodec
import net.minecraft.network.protocol.common.custom.CustomPacketPayload
import net.neoforged.neoforge.network.handling.IPayloadContext
import net.neoforged.neoforge.network.registration.PayloadRegistrar
import kotlin.reflect.KFunction1

fun <T : CustomPacketPayload> PayloadRegistrar.playToClient(
	type: CustomPacketPayload.Type<T>,
	codec: StreamCodec<FriendlyByteBuf, T>,
	handler: KFunction1<IPayloadContext, Unit>
): PayloadRegistrar = playToClient(type, codec) { _, context -> handler(context) }

fun <T : CustomPacketPayload> PayloadRegistrar.playToServer(
	type: CustomPacketPayload.Type<T>,
	codec: StreamCodec<FriendlyByteBuf, T>,
	handler: KFunction1<IPayloadContext, Unit>
): PayloadRegistrar = playToServer(type, codec) { _, context -> handler(context) }
